libzypp: zyppng::Pattern Class Reference

libzypp 17.38.8

zyppng::Pattern Class Reference

Pattern interface. More...

`#include <zypp/Pattern.h>`

Inheritance diagram for zyppng::Pattern:

## Public Types
using | Self = Pattern
using | TraitsType = ResTraits<Self>
using | Ptr = TraitsType::PtrType
using | constPtr = TraitsType::constPtrType
using | NameList = sat::ArrayAttr<IdString, IdString>
using | Contents = sat::SolvableSet
Public Types inherited from zypp::ResObject
using | Self = ResObject
using | TraitsType = ResTraits<Self>
using | Ptr = TraitsType::PtrType
using | constPtr = TraitsType::constPtrType
Public Types inherited from zypp::Resolvable
using | Self = Resolvable
using | TraitsType = ResTraits<Self>
using | Kind = TraitsType::KindType
using | Ptr = TraitsType::PtrType
using | constPtr = TraitsType::constPtrType

## Public Member Functions
bool | isDefault () const
bool | userVisible () const
std::string | category (const Locale &lang_r=Locale()) const
Pathname | icon () const
Pathname | script () const
std::string | order () const
Public Member Functions inherited from zypp::ResObject
template<class TRes>
ResTraits< TRes >::constPtrType | asKind () const
| Convert `this` into a Ptr of a certain Kind.
template<class TRes>
ResTraits< TRes >::PtrType | asKind ()
Vendor | vendor () const
| Vendor.
Public Member Functions inherited from zypp::Resolvable
| operator sat::Solvable () const
| This is a sat::SolvableType.
PoolItem | poolItem () const
| Access the corresponding PoolItem.
Public Member Functions inherited from zypp::sat::SolvableType< Resolvable >
Solvable | satSolvable () const
| Return the corresponding sat::Solvable.
| operator bool () const
IdString | ident () const
ResKind | kind () const
bool | isKind (const ResKind &kind_r) const
std::string | name () const
Edition | edition () const
Arch | arch () const
IdString | vendor () const
Repository | repository () const
RepoInfo | repoInfo () const
bool | isSystem () const
bool | onSystemByUser () const
bool | onSystemByAuto () const
bool | identIsAutoInstalled () const
bool | multiversionInstall () const
bool | isNeedreboot () const
Capability | patternProvides () const
bool | isPatternPackage () const
Capability | productProvides () const
bool | isProductPackage () const
bool | isBlacklisted () const
bool | isRetracted () const
bool | isPtf () const
bool | isPtfMaster () const
bool | isPtfPackage () const
Date | buildtime () const
Date | installtime () const
std::string | asString () const
std::string | asUserString () const
bool | identical (const Solvable &rhs) const
bool | sameNVRA (const Solvable &rhs) const
Capabilities | dep_provides () const
Capabilities | dep_requires () const
Capabilities | dep_conflicts () const
Capabilities | dep_obsoletes () const
Capabilities | dep_recommends () const
Capabilities | dep_suggests () const
Capabilities | dep_enhances () const
Capabilities | dep_supplements () const
Capabilities | dep_prerequires () const
Capabilities | dep (Dep which_r) const
Capabilities | operator[] (Dep which_r) const
Capabilities | provides () const
Capabilities | conflicts () const
Capabilities | obsoletes () const
Capabilities | recommends () const
Capabilities | suggests () const
Capabilities | enhances () const
Capabilities | supplements () const
Capabilities | prerequires () const
CapabilitySet | providesNamespace (const std::string &namespace_r) const
CapabilitySet | valuesOfNamespace (const std::string &namespace_r) const
bool | supportsLocales () const
bool | supportsLocale (const Locale &locale_r) const
bool | supportsRequestedLocales () const
LocaleSet | getSupportedLocales () const
CpeId | cpeId () const
unsigned | mediaNr () const
ByteCount | installSize () const
ByteCount | downloadSize () const
std::string | distribution () const
std::string | summary (const Locale &lang_r=Locale()) const
std::string | description (const Locale &lang_r=Locale()) const
std::string | insnotify (const Locale &lang_r=Locale()) const
std::string | delnotify (const Locale &lang_r=Locale()) const
std::string | licenseToConfirm (const Locale &lang_r=Locale()) const
bool | needToAcceptLicense () const
std::string | lookupStrAttribute (const SolvAttr &attr) const
bool | lookupBoolAttribute (const SolvAttr &attr) const
detail::IdType | lookupIdAttribute (const SolvAttr &attr) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr) const
CheckSum | lookupCheckSumAttribute (const SolvAttr &attr) const
OnMediaLocation | lookupLocation () const
Solvable::IdType | id () const
Public Member Functions inherited from zypp::base::ReferenceCounted
| ReferenceCounted ()
| Default ctor.
| ReferenceCounted (const ReferenceCounted &rhs)
| Copy ctor.
virtual | ~ReferenceCounted ()
| Dtor.
ReferenceCounted & | operator= (const ReferenceCounted &)
| Assignment.
unsigned | refCount () const
| Return reference counter value.
void | ref () const
| Add a reference.
void | unref () const
| Release a reference.

## Auto patterns (libyzpp-14)
Patterns are no longer defined by separate metadate files, but via special dependencies provided by a corresponding patterns- package. The pattern itself requires only its patterns- package. The package contains all further dependencies. This way, patterns are no longer pseudo-installed objects with a computed status, but installed, iff the corresponding patterns- package is installed.
bool | isAutoPattern () const
| This patterns is auto-defined by a patterns- package.
sat::Solvable | autoPackage () const
| The corresponding patterns- package if isAutoPattern.
NameList | includes () const
| Ui hint: included patterns.
NameList | extends () const
| Ui hint: patterns this one extends.
Contents | core () const
| Ui hint: Required Packages.
Contents | depends (bool includeSuggests_r=true) const
| Ui hint: Dependent packages.
Contents | dependsNoSuggests () const
Contents | contents (bool includeSuggests_r=true) const
| The collection of packages associated with this pattern.
Contents | contentsNoSuggests () const
Ptr | make (const sat::Solvable &solvable_r)
| Directly create a certain kind of ResObject from sat::Solvable.
| Pattern (const sat::Solvable &solvable_r)
| Ctor.
| ~Pattern () override
| Dtor.

## Additional Inherited Members
Static Public Member Functions inherited from zypp::base::ReferenceCounted
static void | add_ref (const ReferenceCounted *ptr_r)
| Called by zypp::intrusive_ptr to add a reference.
static void | release (const ReferenceCounted *ptr_r)
| Called by zypp::intrusive_ptr to add a reference.
Public Attributes inherited from zypp::sat::SolvableType< Resolvable >
Capabilities | const
Protected Member Functions inherited from zypp::ResObject
| ResObject (const sat::Solvable &solvable_r)
| Ctor.
| ~ResObject () override
| Dtor.
std::ostream & | dumpOn (std::ostream &str) const override
| Helper for stream output.
| operator sat::Solvable () const
| This is a sat::SolvableType (allow implicit conversion in derived classes).
Protected Member Functions inherited from zypp::Resolvable
| Resolvable (const sat::Solvable &solvable_r)
| Ctor.
| ~Resolvable () override
| Dtor.
std::ostream & | dumpOn (std::ostream &str) const override
| Helper for stream output.
Protected Member Functions inherited from zypp::sat::SolvableType< Resolvable >
| SolvableType ()
SolvableType & | operator= (const SolvableType &)=default
| ~SolvableType ()
Protected Member Functions inherited from zypp::base::ReferenceCounted
virtual void | ref_to (unsigned) const
| Trigger derived classes after refCount was increased.
virtual void | unref_to (unsigned) const
| Trigger derived classes after refCount was decreased.

## Detailed Description

Pattern interface.

Definition at line 31 of file Pattern.h.

## Member Typedef Documentation

## ◆ Self

using zypp::Pattern::Self = Pattern

Definition at line 34 of file Pattern.h.

## ◆ TraitsType

using zypp::Pattern::TraitsType = ResTraits<Self>

Definition at line 35 of file Pattern.h.

## ◆ Ptr

using zypp::Pattern::Ptr = TraitsType::PtrType

Definition at line 36 of file Pattern.h.

## ◆ constPtr

using zypp::Pattern::constPtr = TraitsType::constPtrType

Definition at line 37 of file Pattern.h.

## ◆ NameList

using zypp::Pattern::NameList = sat::ArrayAttr<IdString, IdString>

Definition at line 40 of file Pattern.h.

## ◆ Contents

using zypp::Pattern::Contents = sat::SolvableSet

Definition at line 41 of file Pattern.h.

## Constructor & Destructor Documentation

## ◆ Pattern()

zypp::Pattern::Pattern | ( | const sat::Solvable & | solvable_r | ) |
| protected

Ctor.

Definition at line 173 of file Pattern.cc.

## ◆ ~Pattern()

zypp::Pattern::~Pattern | ( |  | ) |
| overrideprotected

Dtor.

Definition at line 177 of file Pattern.cc.

## Member Function Documentation

## ◆ isDefault()

bool zypp::Pattern::isDefault | ( |  | ) | const

Definition at line 180 of file Pattern.cc.

## ◆ userVisible()

bool zypp::Pattern::userVisible | ( |  | ) | const

Definition at line 183 of file Pattern.cc.

## ◆ category()

std::string zypp::Pattern::category | ( | const Locale & | lang_r = Locale() | ) | const

Definition at line 192 of file Pattern.cc.

## ◆ icon()

Pathname zypp::Pattern::icon | ( |  | ) | const

Definition at line 195 of file Pattern.cc.

## ◆ script()

Pathname zypp::Pattern::script | ( |  | ) | const

Definition at line 198 of file Pattern.cc.

## ◆ order()

std::string zypp::Pattern::order | ( |  | ) | const

Definition at line 201 of file Pattern.cc.

## ◆ isAutoPattern()

bool zypp::Pattern::isAutoPattern | ( |  | ) | const

This patterns is auto-defined by a patterns- package.

Definition at line 204 of file Pattern.cc.

## ◆ autoPackage()

sat::Solvable zypp::Pattern::autoPackage | ( |  | ) | const

The corresponding patterns- package if isAutoPattern.

Definition at line 207 of file Pattern.cc.

## ◆ includes()

Pattern::NameList zypp::Pattern::includes | ( |  | ) | const

Ui hint: included patterns.

Definition at line 220 of file Pattern.cc.

## ◆ extends()

Pattern::NameList zypp::Pattern::extends | ( |  | ) | const

Ui hint: patterns this one extends.

Definition at line 223 of file Pattern.cc.

## ◆ core()

Pattern::Contents zypp::Pattern::core | ( |  | ) | const

Ui hint: Required Packages.

Definition at line 240 of file Pattern.cc.

## ◆ depends()

Pattern::Contents zypp::Pattern::depends | ( | bool | includeSuggests_r = true | ) | const

Ui hint: Dependent packages.

This also includes recommended and suggested (optionally exclude) packages.

Definition at line 258 of file Pattern.cc.

## ◆ dependsNoSuggests()

Contents zypp::Pattern::dependsNoSuggests | ( |  | ) | const
| inline

Definition at line 88 of file Pattern.h.

## ◆ contents()

Pattern::Contents zypp::Pattern::contents | ( | bool | includeSuggests_r = true | ) | const

The collection of packages associated with this pattern.

This also evaluates the patterns includes/extends relation. Optionally exclude `SUGGESTED` packages.

Definition at line 284 of file Pattern.cc.

## ◆ contentsNoSuggests()

Contents zypp::Pattern::contentsNoSuggests | ( |  | ) | const
| inline

Definition at line 97 of file Pattern.h.

## Friends And Related Symbol Documentation

## ◆ make

Ptr make | ( | const sat::Solvable & | solvable_r | ) |
| friend

Directly create a certain kind of ResObject from sat::Solvable.

If the sat::Solvables kind is not appropriate, a NULL pointer is returned.

sat::Solvable s;
ResObject::Ptr p( makeResObject( s ) );
ResObject::Ptr q( make<ResObject>( s ) );
Package::Ptr pkg( make<Package>( s ) );
zypp::ResObject::makeResObject
friend ResObject::Ptr makeResObject(const sat::Solvable &solvable_r)
Create ResObject from sat::Solvable.
Definition ResObject.cc:43
zyppng::Package::Ptr
TraitsType::PtrType Ptr
Definition Package.h:38
zyppng::Pattern::make
friend Ptr make(const sat::Solvable &solvable_r)
Directly create a certain kind of ResObject from sat::Solvable.
Definition ResObject.h:118
zyppng::ResObject::Ptr
TraitsType::PtrType Ptr
Definition ResObject.h:42
zyppng::sat::Solvable
A Solvable object within the sat Pool.
Definition solvable.h:65

Todo
  make<> was a poor choice (AFAIR because gcc had some trouble with asKind<>(sat::Solvable)). Remove it in favour of asKind<>(sat::Solvable)

Definition at line 118 of file ResObject.h.

The documentation for this class was generated from the following files:

- zypp/Pattern.h
- zypp/Pattern.cc